#pragma once
/********************************************************************
	filename: 	mOPT_SAV.h

	purpose:	mOTP ̬֤ӿ
*********************************************************************/

#ifndef _M_OTP_SAV_H__
#define _M_OTP_SAV_H__

#ifdef __cplusplus
extern "C" {
#endif

#define IN	
#define OUT

#ifdef _WIN32
#include <Windows.h>
#else
#define WINAPI 
#endif


	//mOTP󷵻ֵ
	enum _enum_mOTP_ErrorCode_ {
		MOTP_OK = 0,						//ɹ
		MOTP_INVALID_SEED = 0x0F00001,		//ЧԿ
		MOTP_INVALID_SN,					//кŴ
		MOTP_INVALID_FILE,					//Կļ
		MOTP_INVALID_PWD,					//ЧĶ̬
		MOTP_PWD_REUSING,					//̬
		MOTP_INVALID_AUTHWINDOW,			//Ч֤
		MOTP_AUTH_FAILED,					//֤ʧ
		MOTP_AUTH_LOCKED,					//
		MOTP_INVALID_VER,					//汾
		MOTP_UNSUPPORTED,					//δ֧
		MOTP_INTERNAL,						//ڲ
		MOTP_INVALID_TYPE,					//OTPʹ
		MOTP_INVALID_HALG					//ֵ֧Ĺϣ㷨
	};

	enum _enum_mOTP_AuthWindow_ {
		MOTP_AUTHWINDOW_NONE,
		MOTP_AUTHWINDOW_SMALL = 2,
		MOTP_AUTHWINDOW_MEDIUM = 5,
		MOTP_AUTHWINDOW_BIG = 10
	};

	enum _enum_OTPType {
		MOTP_TOTP,
		MOTP_HOTP,
		MOTP_CROTP		//Challenge_Response
	};
	enum _enum_SKeyAlgorithm {
		MOTP_SBASE32,
		MOTP_SHEX
	};
	enum _enum_OTPAlgorithm {
		MOTP_HSHA1,
		MOTP_HSHA224,
		MOTP_HSHA256,
		MOTP_HSHA384,
		MOTP_HSHA512,
		MOTP_HMD5,
		MOTP_HSM3
	};

#pragma pack(1)
	typedef struct _OTP_seed_infor_st
	{
		unsigned char mgc_h;		// mgc_h=0x5e   ṹ峤94ֽ
		unsigned char type;			//otp   MOTP_TOTP\MOTP_HOTP
		unsigned char hash;			//㷨 MOTP_HSHA1\MOTP_HSHA224\MOTP_HSHA256\MOTP_HSHA384\MOTP_HSHA512\MOTP_HMD5\MOTP_HSM3
		unsigned char skeyT;		//ܷʽ  MOTP_SBASE32\MOTP_SHEX
		char secret[84];			// 

		unsigned int counter;		//hotp C 
		unsigned char period;		//totp eg:30s 60s 

		unsigned char mgc_t;		// mgc_t=0x5e  
	}OTP_SEED_INFO;
#pragma pack()

	/**
	*****************ʹ˵**********************	
	1׼OTP֤
		 mOTP_VerifyPwd ӿ,OTP_SEED_INFOϢ

	2˽OTP֤
		2.1 ȵ mOTP_SeedEnv ӿڻȡͻԿ(ڼ¼ʧ̬ܶĹȨ޿)
			szSeedInfo Ϊ 40λOEMԿʱ,ֻ֤60s,6λ̬hsha1㷨ʱ͵OTP,M200Ӳ
			szSeedInfo Ϊ OTP_SEED_INFO ʱ,ȿ֤ʱ͵OTPҲ֤¼͵OTP
		
		2.2 Ȼ mOTP_VerifyPwd ӿ,ͻԿ

	3˽OTPͬ
		 mOTP_SyncTime ӿ,ͻԿ
		
	3˽OTP
		 mOTP_UnLocked ӿ,ͻԿ
	*/



	/*
	*	mOTP_GetVer ȡ汾
	*
	*/
	const char * WINAPI mOTP_GetVer();


	/*
	*	mOTP_SeedEnv Կװ
	*	nVer		[IN]		汾ţ ȡֵΪ1,2ǰ汾Ϊ2
	*	szSN		[IN]		ûк  >4 <24
	*	szSeedInfo	[IN]		OTP_SEED_INFOṹ  OEMԿ   ǰ볤Ȳ31λ
	*	szEnvRes	[OUT]		ͻԿ, С1024ֽ
	*	ֵ					mOTP󷵻ֵ
	*/
	int WINAPI mOTP_SeedEnv(IN unsigned int nVer, IN char *szSN, IN char * szSeedInfo, OUT char *szEnvRes);

	/*
	*	mOTP_VerifyPwd ֤OTP
	*	szSeedInfo	[IN, OUT]	OTP_SEED_INFOṹ  mOTP_SeedEnvȡĿͻԿϢýӿں󣬵ҪszSeedInfo
	*	szPwd		[IN]		ûɵĶ̬룬һ68λ  5\6\7\8
	*	nAuthWindow	[IN]		֤ڣȡֵΪ_enum_mOTP_AuthWindow_ĬΪMOTP_AUTHWINDOW_BIG
	*	nRes		[OUT]		֤0ʧܣ1ɹ
	*	ֵ					mOTP󷵻ֵ
	*/
	int WINAPI mOTP_VerifyPwd(IN OUT char *szSeedInfo, IN const unsigned int nAuthWindow, IN const char * szPwd, OUT unsigned int *nRes);

	/*
	*	mOTP_SyncTime ʱ¼ͬ
	*	szSeedInfo	[IN, OUT]	ԿϢýӿں󣬵ҪszSeedInfo
	*	szPwd		[IN]		ûɵĶ̬룬һ68λ
	*	ֵ					mOTP󷵻ֵ
	*/
	int WINAPI mOTP_SyncTime(IN OUT char *szSeedInfo, IN const char * szPwd);

	/*
	*	mOTP_UnLocked 
	*	szSeedInfo	[IN, OUT]	ԿϢýӿں󣬵ҪszSeedInfo
	*	nAuthWindow	[IN]		֤ڣȡֵΪ_enum_mOTP_AuthWindow_ĬΪMOTP_AUTHWINDOW_BIG
	*	szPwd		[IN]		ûɵĶ̬룬һ68λ
	*	ֵ					mOTP󷵻ֵ
	*/
	int WINAPI mOTP_UnLocked(IN OUT char *szSeedInfo, IN const unsigned int nAuthWindow, IN const char * szPwd);


	//ʱotpĻ׼꣬1Ч, ׼겻С1970
	int WINAPI mOTP_TotpSetUTCyear(int year);


#ifdef __cplusplus
}
#endif

#endif

//EOF

