<?PHP
/**************************************
 * 
 * 类名: mToken OTP Server
 * 
 * 说明: 此类是单件模式封装,保证程序运行中只实例化一个类减少系统开销.getInstance()函数为全局访问点,
 * 		 在你第一次调用这个方法的时候,它创建一个示例,把它存在一个私有的静态变量中,并且给你返回示例,
 *		 下一次,它将仅仅给你返回那个已经创建的实例的句柄
 * 
 **************************************/
class mTokenOTPServer {

	static private $_dog = null;

	private function __construct()
	{
		if (extension_loaded('mTokenOTP'))
		{
			//echo 'mToken OTP 扩展加载成功';
		} else {
			echo 'mToken OTP 扩展加载失败';
		}
	}

	
	public function SetUTCYear($nYear)
	{
		return mTokenOTP_SetUTCYear($nYear);
	}

	public function SeedEnv($nVer, $UserSN, $UserSeed, $EnvRes)
	{
		return mTokenOTP_SeedEnv($nVer, $UserSN, $UserSeed, $EnvRes);
	}

	public function VerifyPwd($UserSeed, $nAuthWindow, $OTPPin, $NewUserSeed)
	{
		return mTokenOTP_VerifyPwd($UserSeed,$nAuthWindow, $OTPPin, $NewUserSeed);
	}
	
	public function SyncTime($UserSeed, $OTPPin, $NewUserSeed)
	{
		return mTokenOTP_SyncTime($UserSeed, $OTPPin, $NewUserSeed);
	}

	public function UnLocked($UserSeed, $nAuthWindow, $OTPPin, $NewUserSeed)
	{
		return mTokenOTP_UnLocked($UserSeed,$nAuthWindow, $OTPPin, $NewUserSeed);
	}


	//不带参实例化,参数为默认
	public static function getInstance()
	{
		if(!self::$_dog instanceof self){
			self::$_dog = new self();
		}
		return self::$_dog;
	}

	private function __clone()
	{
		
	}	
} 

?>
